<?php
 
 
 

namespace PhpWA\Protocol\Proto\Message;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class ButtonsResponseMessage extends \Google\Protobuf\Internal\Message
{
    


    protected $selectedButtonId = null;
    


    protected $contextInfo = null;
    


    protected $type = null;
    protected $response;

    











    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getSelectedButtonId()
    {
        return isset($this->selectedButtonId) ? $this->selectedButtonId : '';
    }

    public function hasSelectedButtonId()
    {
        return isset($this->selectedButtonId);
    }

    public function clearSelectedButtonId()
    {
        unset($this->selectedButtonId);
    }

    




    public function setSelectedButtonId($var)
    {
        GPBUtil::checkString($var, True);
        $this->selectedButtonId = $var;

        return $this;
    }

    



    public function getContextInfo()
    {
        return $this->contextInfo;
    }

    public function hasContextInfo()
    {
        return isset($this->contextInfo);
    }

    public function clearContextInfo()
    {
        unset($this->contextInfo);
    }

    




    public function setContextInfo($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\ContextInfo::class);
        $this->contextInfo = $var;

        return $this;
    }

    



    public function getType()
    {
        return isset($this->type) ? $this->type : 0;
    }

    public function hasType()
    {
        return isset($this->type);
    }

    public function clearType()
    {
        unset($this->type);
    }

    




    public function setType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\Message\ButtonsResponseMessage\Type::class);
        $this->type = $var;

        return $this;
    }

    



    public function getSelectedDisplayText()
    {
        return $this->readOneof(2);
    }

    public function hasSelectedDisplayText()
    {
        return $this->hasOneof(2);
    }

    




    public function setSelectedDisplayText($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(2, $var);

        return $this;
    }

    


    public function getResponse()
    {
        return $this->whichOneof("response");
    }

}

